include 'Vram.inc'
include 'ZeroPage.inc'

ext InitVram, InitSound, SoundHandler

dseg
SaveInt:
    defw 0
TimerCount: 
    defb 0

cseg
Init: public Init
    pha
        lda #$30 | sta $D0 ; hide cursor

        lda #ScreenMode | sta $fe07 | sta $282
        lda #low(VramOrg shr 1) | sta $fe02
        lda #high(VramOrg shr 1) | sta $fe03

        ; palette
        lda #$30 | sta $fe08
        lda #$35 | sta $fe09

        ; jsr InitVram
        jsr InitSound

        sei
            lda #0 | sta TimerCount
            lda $0204 | sta SaveInt
            lda $0205 | sta SaveInt+1
            lda #low Handler | sta $0204
            lda #high Handler | sta $0205
            lda #$04 | sta $fe00
        cli
    pla
rts


Handler: public Handler
    pha
        lda $fe00
        and #$04
        if ne
            inc TimerCount
            jsr SoundHandler
        endif
        ; lda #$f0 | sta $fe00
    pla
jmp (SaveInt)
; jmp $db89
;     cli
; rti


cseg
WaitTimer: public WaitTimer
    sta <ZB0
    do
        lda TimerCount
        cmp <ZB0
    while cc | wend
    sei
        lda #0 | sta TimerCount
    cli
rts
