include 'ZeroPage.inc'
include 'Vram.inc'

OffByte equ ScreenMode
OnByte equ OffByte or 2

tempo equ 220/3
tempo_denom equ 500/3

zseg
pScore:
    defw 0
dseg
toneLen:
    defb 0
time: 
    defb 0

cseg
InitSound: public InitSound
    lda #0
    sta <pScore
    sta <pScore+1
    sta time
rts


SoundHandler: public SoundHandler
    pha
    txa | pha
    tya | pha
        lda <pScore | ora <pScore+1
        if ne
            lda time
            sec | sbc #tempo
            sta time
            if cc
                dec toneLen
                if eq
                    ldy #0 | lda (<pScore),y
                    if eq
                        ; end
                        lda #OffByte | sta $fe07
                        lda #0
                        sta <pScore
                        sta <pScore+1
                        jmp exit
                    endif
                    sta toneLen
                    iny | lda (<pScore),y
                    if ne
                        tax | dex
                        lda cycles,x | sta $fe06
                        lda #OnByte | sta $fe07
                    else
                        lda #OffByte | sta $fe07
                    endif
                    lda <pScore | clc|adc #2 | sta <pScore
                    lda <pScore+1 | adc #0 | sta <pScore+1
                endif
                lda time
                clc | adc #tempo_denom
                sta time
            endif
        endif
        exit:
    pla | tay
    pla | tax
    pla
rts


Melody:
    pha
        sei
            stx <pScore
            sty <pScore+1
            lda #1
            sta toneLen
        cli
    pla
rts


MelodyWait:
    jsr Melody
    pha
        do
            lda <pScore | ora <pScore+1
        while ne | wend
    pla
rts


loose_notes:
    defb 1,C4, 0
Sound_Loose: public Sound_Loose
    ldx #low loose_notes
    ldy #high loose_notes
jmp MelodyWait


hit_notes:
    defb 1,F4, 1,F4S, 1,G4, 1, G4S, 1,A4, 1,A4S, 1,B4
    defb 1,C5, 1,C5S, 1,D5, 1,D5S, 1,E5, 1,F5
    defb 0
Sound_Hit: public Sound_Hit
    ldx #low hit_notes
    ldy #high hit_notes
jmp Melody


beep_notes:
    defb 1,A4, 0
Sound_Get: public Sound_Get
    ldx #low beep_notes
    ldy #high beep_notes
jmp MelodyWait


start_notes:
    defb 5,C4,1,0, 5,G4,1,0, 5,E4,1,0, 5,G4,1,0, 23,C5,1,0
    defb 0
Sound_Start: public Sound_Start
    ldx #low start_notes
    ldy #high start_notes
jmp MelodyWait


clear_notes:
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0, 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear: public Sound_Clear
    ldx #low clear_notes
    ldy #high clear_notes
jmp MelodyWait


over_notes: 
	defb 5,C5,1,0, 5,G4,1,0, 5,E4,1,0, 5,C5,1,0, 5,B4,1,0, 5,G4,1,0, 5,E4,1,0, 5,B4,1,0
	defb 11,A4,1,0, 11,B4,1,0, 23,C5,1,0
    defb 0
Sound_GameOver: public Sound_GameOver
    ldx #low over_notes
    ldy #high over_notes
jmp MelodyWait



C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18

N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2
N16 equ N8/2

cycles:
defb 238 ; C4
defb 225 ; C4S
defb 212 ; D4
defb 200 ; D4S
defb 189 ; E4
defb 178 ; F4
defb 168 ; F4S
defb 159 ; G4
defb 150 ; G4S
defb 141 ; A4
defb 134 ; A4S
defb 126 ; B4
defb 119 ; C5
defb 112 ; C5S
defb 106 ; D5
defb 100 ; D5S
defb 94 ; E5
defb 89 ; F5
