include 'Zeropage.inc'
include 'Vram.inc'
include 'VVram.inc'

ext VVram
ext Chars

VramTop equ Vram+4*VramStep
ToNextRow equ CharHeight*(VramWidth-VVramWidth)

pSource equ ZW2
pDestination equ ZW1
pVVram equ ZW0
pBackup equ ZW3
yCount equ ZB0
xOffset equ ZB1
xCount equ ZB1

pVram equ ZW1
pChars equ ZW0
XPos equ ZB2
YPos equ ZB3
char equ ZB4

dseg
Backup:
    defs VVramWidth*VVramHeight


cseg
ClearScreen: public ClearScreen
    pha
        lda #low VramOrg | sta pDestination
        lda #high VramOrg | sta pDestination+1
        lda #0
        ldx #$80-high VramOrg
        do
            ldy #0
            do
                sta (<pDestination),y
                iny
            while ne | wend
            inc <pDestination+1
            dex
        while ne | wend

        lda #low Backup | sta <pDestination
        lda #high Backup | sta <pDestination+1
        ldx #VVramHeight
        do
            lda #0
            ldy #0
            do
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pDestination | clc|adc #VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


cseg
Put1:
    sta <pSource
    lda #0 | sta <pSource+1
    asl <pSource | rol <pSource+1 ; *2
    asl <pSource | rol <pSource+1 ; *4
    asl <pSource | rol <pSource+1 ; *8
    lda <pSource | clc|adc #low Chars | sta <pSource
    lda <pSource+1 | adc #high Chars sta <pSource+1
    ldy #0
    do
        lda (<pSource),y
        sta (<pDestination),y
        iny
        cpy #CharHeight
    while ne | wend
rts


; dseg
; VPut_@Param0: public VPut_@Param0
; VPut_pVram:
;     defw 0
; VPut_@Param1: public VPut_@Param1
; VPut_c:
;     defb 0
; cseg
; VPut_: public VPut_
;     pha
;         lda VPut_pVram | sta <pDestination
;         lda VPut_pVram+1 | sta <pDestination+1
        
;         lda VPut_c
;         jsr Put1
;     pla
; rts


cseg
VVramToVram: public VVramToVram
    pha
        lda #low VVram | sta <pVVram
        lda #high VVram | sta <pVVram+1
        lda #low VramTop | sta <pDestination
        lda #high VramTop | sta <pDestination+1
        lda #low Backup | sta <pBackup
        lda #high Backup | sta <pBackup+1
        lda #VVramHeight | sta <yCount
        do
            ldy #0
            do
                lda (<pVVram),y
                cmp (<pBackup),y
                if ne
                    sta (<pBackup),y
                    sty <xOffset
                    jsr Put1
                    ldy <xOffset
                endif
                lda <pDestination | clc | adc #low CharHeight | sta <pDestination
                lda <pDestination+1 | adc #high CharHeight | sta <pDestination+1

                iny
                cpy #VVramWidth
            while ne | wend

            lda <pDestination | clc | adc #low ToNextRow | sta <pDestination
            lda <pDestination+1 | adc #high ToNextRow | sta <pDestination+1

            lda <pVVram | clc | adc #low VVramWidth | sta <pVVram
            lda <pVVram+1 | adc #high VVramWidth | sta <pVVram+1

            lda <pBackup | clc | adc #low VVramWidth | sta <pBackup
            lda <pBackup+1 | adc #high VVramWidth | sta <pBackup+1

            dec <yCount
        while ne | wend
    pla
rts


cseg
Locate: public Locate
    lda <yPos
    asl a ;*2
    asl a ;*2
    clc|adc <yPos ;*5
    sta <pVram
    lda #0
    sta <pVram+1
    asl <pVram | rol <pVram+1 ; *10
    asl <pVram | rol <pVram+1 ; *20
    asl <pVram | rol <pVram+1 ; *40
    lda <pVram | clc|adc <xPos | sta <pVram
    lda <pVram+1 | adc #0 | sta <pVram+1
    asl <pVram | rol <pVram+1 ; *2
    asl <pVram | rol <pVram+1 ; *4
    asl <pVram | rol <pVram+1 ; *8
    lda <pVram | clc|adc #low Vram | sta <pVram
    lda <pVram+1 | adc #high Vram | sta <pVram+1
rts


PrintC: public PrintC
    lda <char
    clc | adc #-$20
    jsr Put1
    lda <pVram | clc|adc #VramStep | sta <pVram
    lda <pVram+1 | adc #0 | sta <pVram+1
rts


PrintS: public PrintS
    jsr Locate

    ldy #0
    do
        lda (<pChars),y
    while ne
        sta <char
        iny
        tya | pha
            jsr PrintC
        pla | tay
    wend
rts


Print1x1: public Print1x1
    jsr Locate
    lda <char
jmp Put1


Print2x2: public Print2x2
    jsr Locate
    lda #2 | sta <yCount
    do
        lda #2 | sta <xCount
        do
            lda <char
            jsr Put1
            inc <char
            lda <pVram | clc|adc #VramStep | sta <pVram
            lda <pVram+1 | adc #0 | sta <pVram+1
            dec <xCount
        while ne | wend
        lda <pVram | clc|adc #low(VramRowSize-VramStep*2) | sta <pVram
        lda <pVram+1 | adc #high(VramRowSize-VramStep*2) | sta <pVram+1
        dec <yCount
    while ne | wend
rts


PrintSpace2x2: public PrintSpace2x2
    jsr Locate
    lda #2 | sta <yCount
    do
        
        lda #2 | sta <xCount
        do
            lda #0
            jsr Put1
            lda <pVram | clc|adc #VramStep | sta <pVram
            lda <pVram+1 | adc #0 | sta <pVram+1
            dec <xCount
        while ne | wend
        lda <pVram | clc|adc #low(VramRowSize-VramStep*2) | sta <pVram
        lda <pVram+1 | adc #high(VramRowSize-VramStep*2) | sta <pVram+1
        dec <yCount
    while ne | wend
rts
