include "KeyBits.inc"
include "VVram.inc"
include "Vram.inc"
include "Chars.inc"
include "Zeropage.inc"

dseg
man.x defb 0 | public man.x
man.y defb 0 | public man.y
man.status.die defb 0 | public man.status.die
prevDir: defw 0
seq.ptr defw 0
seq.index defb 0
default defb 0
chr defb 0
lastButton defb 0

cseg

; direction structure
Dir.key equ 0
Dir.x equ Dir.key+1
Dir.y equ Dir.x+1
Dir.seq equ Dir.y+1
Dir.stop equ Dir.seq+4
Dir.knife.dir equ Dir.stop+1
Dir.knife.x equ Dir.knife.dir+1
Dir.knife.y equ Dir.knife.x+1
Dir.size equ Dir.knife.y+1
Dir.count equ 4

Directions:
    ; left direction
    defb Keys_Left
    defb -1,0
    defb Char_Man_Left1, Char_Man_Left0, Char_Man_Left1, Char_Man_Left2
    defb Char_Man_Stop_Left
    defb 0
    defb 0,0
    ; right direction
    defb Keys_Right
    defb 1,0
    defb Char_Man_Right1, Char_Man_Right0, Char_Man_Right1, Char_Man_Right2
    defb Char_Man_Stop_Right
    defb 1
    defb 1,0
    ; up direction
    defb Keys_Up
    defb 0,-1
    defb Char_Man_Up1, Char_Man_Up0, Char_Man_Up1, Char_Man_Up2
    defb Char_Man_Stop_Up
    defb 2
    defb 0,0
    ; down direction
    defb Keys_Down
    defb 0,1
    defb Char_Man_Down1, Char_Man_Down0, Char_Man_Down1, Char_Man_Down2
    defb Char_Man_Stop_Down
    defb 3
    defb 0,1
DieSeq:
    defb Char_Man_Stop_Left, Char_Man_Stop_Down, Char_Man_Die2, Char_Man_Die3

ext CG.Man
ext CopyMem
ext ScanKeys
ext stage.offset, ToMapSize
ext map.width, map.height, base.x, base.y, Tst2x2, Put2x2, Stage.Clear
ext Kn.Invent, Kn.Start
ext goal.x,goal.y

Man.Init:    public Man.Init
    ldy stage.offset
    lda (<ZW2),y
    iny
    jsr ToMapSize
    sta man.x
    lda (<ZW2),y
    iny
    jsr ToMapSize
    sta man.y
    sty stage.offset
    lda #low(directions + Dir.size) ; right direction
    sta prevDir
    lda #high(directions + Dir.size)
    sta prevDir+1
    lda #Char_Man_Stop_Right
    sta chr
    lda #0
    sta seq.index
    sta man.status.die
UpdateBasePosition:
    lda map.width
    sec
    sbc #VVramWidth
    sta <ZB0
    lda map.height
    sec
    sbc #VVramHeight
    sta <ZB1
    
    lda man.x
    sec
    sbc #VVramWidth/2
    if cc
        lda #0
    endif
    cmp <ZB0
    if cs
        lda <ZB0
    endif
    sta base.x

    lda man.y
    sec
    sbc #VVramHeight/2
    if cc
        lda #0
    endif
    cmp <ZB1
    if cs
        lda <ZB1
    endif
    sta base.y
rts

    dseg
    key defb 0
    cseg
Man.Move:    public Man.Move
    lda man.status.die
    if ne
        rts
    endif

    jsr ScanKeys
    sta key

    lda #low directions | sta <ZW2.low
    lda #high directions | sta <ZW2.high

    lda #Dir.count | sta <ZB0
    do
        lda key
        ldy #Dir.key
        and (<ZW2),y
        if ne
            ldy #Dir.x | lda man.x | clc | adc (<ZW2),y | sta <ZB2
            ldy #Dir.y | lda man.y | clc | adc (<ZW2),y | sta <ZB3
            jsr Tst2x2
            if eq 
                lda <ZW2.low | sta prevDir
                lda <ZW2.high | sta prevDir+1
                jmp CanMove
            endif
        endif
        lda <ZW2.low | clc | adc #Dir.size | sta <ZW2.low
        lda <ZW2.high | adc #0 | sta <ZW2.high

        dec <ZB0
    while ne | wend

    lda key
    and #Keys_Dir
    if ne
        lda prevDir | sta <ZW2.low
        lda prevDir+1 | sta <ZW2.high
        ldy #Dir.x | lda man.x | clc | adc (<ZW2),y | sta <ZB2
        ldy #Dir.y | lda man.y | clc | adc (<ZW2),y | sta <ZB3
        jsr Tst2x2
        if eq
            CanMove:
            lda <ZB2 | sta man.x
            lda <ZB3 | sta man.y

            lda seq.index | clc | adc #1 | and #3 | sta seq.index
            clc|adc #Dir.seq
            tay
            lda (<ZW2),y | sta chr
            jsr UpdateBasePosition

            lda goal.x
            cmp man.x
            if eq
                lda goal.y
                cmp man.y
                if eq 
                    inc Stage.Clear
                endif
            endif
            jmp TestButton
        endif
    endif

    lda prevDir | sta <ZW2.low
    lda prevDir+1 | sta <ZW2.high
    ldy #Dir.Stop | lda (<ZW2),y | sta chr
    lda #-1 | sta seq.index
    
    TestButton:
    lda key
    and #Keys_Button0
    if eq
        lda #0
        sta lastButton
        rts
    endif
    lda lastButton
    if ne
        rts
    endif
    inc lastButton

    lda Kn.Invent
    if eq
        rts
    endif
    lda man.x
    ldy #Dir.knife.x | clc | adc (<ZW2),y
    sta <ZB2

    lda man.y
    ldy #Dir.knife.y | clc | adc (<ZW2),y
    sta <ZB3

    ldy #Dir.knife.dir | lda (<ZW2),y | sta <ZB4
jmp Kn.Start


Man.Draw: public Man.Draw
    lda man.x
    sta <ZB2
    lda man.y
    sta <ZB3
    lda chr
    sta <ZB4
    jsr Put2x2
rts


extrn VVramToVram, Sound_Loose
Man.Die:    public Man.Die
    ldx #0
    lda #10
    do
        pha
            txa | pha
                lda DieSeq,x | inx | sta <ZB4
                lda man.x | sta <ZB2
                lda man.y | sta <ZB3
                jsr Put2x2
                jsr VVramToVram
                jsr Sound_Loose
            pla | tax
            inx
            cpx #4
            if eq
                ldx #0
            endif
        pla
        sec | sbc #1
    while ne | wend
rts
