include "Zeropage.inc"
include "VVram.inc"
include "Vram.inc"
include "Chars.inc"

status.x equ LeftEnd + VVramWidth + 1
Char_Remain equ Char_Man

ext PrintS, PrintC, Print2x2, Print1x1, PrintSpace2x2, Locate, ClearScreen
ext Score, HiScore, Stage, Stage.Time

    dseg
drawn defw 0
drawn.low equ drawn
drawn.high equ drawn+1

    cseg

PrintNumber:
    lda #low 10000 | sta drawn.low
    lda #high 10000 | sta drawn.high
    jsr PrintDigit

    lda #low 1000 | sta drawn.low
    lda #high 1000 | sta drawn.high
    jsr PrintDigit

    PrintNumber3:
    lda #low 100 | sta drawn.low
    lda #high 100 | sta drawn.high
    jsr PrintDigit

    lda #low 10 | sta drawn.low
    lda #high 10 | sta drawn.high
    jsr PrintDigit

    lda <ZW0.low
    clc | adc #'0' | sta <ZB4
jmp PrintC

PrintDigit:
    lda #'0'
    sta <ZB4
    do
        inc <ZB4
        lda <ZW0.low | sec | sbc drawn.low | sta <ZW0.low
        lda <ZW0.high | sbc drawn.high | sta <ZW0.high
    while cs | wend
    dec <ZB4
    lda <ZW0.low | clc | adc drawn.low | sta <ZW0.low
    lda <ZW0.high | adc drawn.high | sta <ZW0.high
    jsr PrintC
rts


PrintByte:
    lda #100 | sta drawn.low
    jsr PrintDigitB
PrintByte2:
    lda #10 | sta drawn.low
    jsr PrintDigitB
    lda <ZW0.low
    clc | adc #'0' | sta <ZB4
jmp PrintC

PrintDigitB:
    lda #'0'
    sta <ZB4
    do 
        inc <ZB4
        lda <ZW0.low | sec | sbc drawn.low | sta <ZW0.low
    while cs | wend
    
    dec <ZB4
    lda <ZW0.low | clc | adc drawn.low | sta <ZW0.low
    jsr PrintC
rts


PrintScore: public PrintScore
    lda Score | sta <ZW0.low
    lda Score+1 | sta <ZW0.high

    lda #status.x | sta <ZB2
    lda #1 | sta <ZB3
    jsr Locate

    jsr PrintNumber
    lda #'0' | sta <ZB4
    jsr PrintC

    lda HiScore | sta <ZW0.low
    lda HiScore+1 | sta <ZW0.high
    lda #status.x | sta <ZB2
    lda #5 | sta <ZB3
    jsr Locate

    jsr PrintNumber
    lda #'0' | sta <ZB4
    jsr PrintC
rts

ext Stage.Time
PrintTime: public PrintTime
    lda Stage.Time | sta <ZW0.low
    lda Stage.Time+1 | sta <ZW0.high

    lda #status.x+3 | sta <ZB2
    lda #11 | sta <ZB3
    jsr Locate

jmp PrintNumber3



extrn Kn.Invent
Print.Kn.Invent:  public Print.Kn.Invent
    lda #status.x | sta <ZB2
    lda #VVramHeight - 4 | sta <ZB3

    lda Kn.Invent
    sta <ZB5
    do | while ne
        lda #Char_Knife_Left | sta <ZB4
        jsr Print1x1
        inc <ZB2
        dec <ZB5
    wend
    lda #4
    sec | sbc Kn.Invent
    sta <ZB5
    do 
        lda #Char_Space | sta <ZB4
        jsr Print1x1
        inc <ZB2
        dec <ZB5
    while ne | wend
rts


extrn Man.Count
Print.Men:
    lda #status.x | sta <ZB2
    lda Man.Count
    if ne
        do
            sec | sbc #1
        while ne
            pha
                lda <ZB2 | pha
                    lda #Char_Remain | sta <ZB4
                    lda #VVramHeight - 2 | sta <ZB3
                    jsr Print2x2
                pla | clc | adc #2 | sta <ZB2
            pla
        wend
    endif
  
    lda #4
    sec | sbc Man.Count
    do
        pha
            lda <ZB2 | pha
                lda #VVramHeight - 2 | sta <ZB3
                jsr PrintSpace2x2
            pla | clc | adc #2 | sta <ZB2
        pla
        sec | sbc #1
    while ne | wend
rts


Str.Score: defb 'SCORE',0
Str.High: defb 'HIGH',0
Str.Stage: defb 'STAGE',0
Str.Time: defb 'TIME',0

PrintStatus: public PrintStatus
    lda #status.x | sta <ZB2
    lda #0 | sta <ZB3
    lda #low Str.Score | sta <ZW0.low
    lda #high Str.Score | sta <ZW0.high
    jsr PrintS

    lda #status.x | sta <ZB2
    lda #3 | sta <ZB3
    lda #low Str.High | sta <ZW0.low
    lda #high Str.High | sta <ZW0.high
    jsr PrintS

    lda #status.x | sta <ZB2
    lda #4 | sta <ZB3
    lda #low Str.Score | sta <ZW0.low
    lda #high Str.Score | sta <ZW0.high
    jsr PrintS

    lda #status.x | sta <ZB2
    lda #7 | sta <ZB3
    lda #low Str.Stage | sta <ZW0.low
    lda #high Str.Stage | sta <ZW0.high
    jsr PrintS

    lda #status.x+4 | sta <ZB2
    lda #8 | sta <ZB3
    jsr Locate
    lda stage
    clc | adc #1
    sta <ZW0.low
    jsr PrintByte2

    lda #status.x | sta <ZB2
    lda #10 | sta <ZB3
    lda #low Str.Time | sta <ZW0.low
    lda #high Str.Time | sta <ZW0.high
    jsr PrintS

    jsr PrintScore
    jsr PrintTime
    jsr Print.Kn.Invent
    jsr Print.Men
rts


WhiteBox:
    lda #VVramHeight/2 - 1
    do
        pha
            sta <ZB3
            lda #LeftEnd+(VVramWidth - 11)/2 | sta <ZB2
            jsr Locate
            lda #11
            do
                pha
                    lda #' ' | sta <ZB4
                    jsr PrintC
                pla
                sec | sbc #1
            while ne | wend
        pla
        clc | adc #1
        cmp #VVramHeight/2 + 2
    while ne | wend
rts

Str.Over:   defb 'GAME OVER',0
Print.Over: public Print.Over
    jsr WhiteBox
    lda #LeftEnd+(VVramWidth - 9)/2 | sta <ZB2
    lda #(VVramHeight / 2) | sta <ZB3
    jsr Locate
    lda #low Str.Over | sta <ZW0.low
    lda #high Str.Over | sta <ZW0.high
jmp PrintS


Str.Timeup:   defb 'TIME UP',0
PrintTimeup: public PrintTimeup
    jsr WhiteBox
    lda #LeftEnd+(VVramWidth - 7)/2 | sta <ZB2
    lda #(VVramHeight / 2) | sta <ZB3
    jsr Locate
    lda #low Str.Timeup | sta <ZW0.low
    lda #high Str.Timeup | sta <ZW0.high
jmp PrintS

Str.Chars: defb '--- CHARACTERS ---',0
Str.Man: defb 'MAN',0
Str.Chaser: defb 'CHASER',0
Str.Disturber: defb 'DISTURBER',0
Str.Exit: defb 'EXIT',0
Str.Push: defb 'PUSH RETURN KEY',0

TitleScreen: public TitleScreen
    jsr ClearScreen
    jsr PrintStatus

    lda #Char_M | sta <ZB6
    lda #LeftEnd+8
    do
        pha
            sta <ZB2
            lda #1 | sta <ZB3
            lda <ZB6 | sta <ZB4
            jsr Print2x2
            lda <ZB6 | clc | adc #4 | sta <ZB6
        pla
        clc | adc #2
        cmp #LeftEnd+8+2*4
    while ne | wend

    lda #LeftEnd+6 | sta <ZB2
    lda #7 | sta <ZB3
    lda #Char_Remain | sta <ZB4
    jsr Print2x2

    lda #LeftEnd+6 | sta <ZB2
    lda #10 | sta <ZB3
    lda #Char_Chaser | sta <ZB4
    jsr Print2x2

    lda #LeftEnd+6 | sta <ZB2
    lda #13 | sta <ZB3
    lda #Char_Disturber | sta <ZB4
    jsr Print2x2

    lda #LeftEnd+6 | sta <ZB2
    lda #16 | sta <ZB3
    lda #Char_Goal | sta <ZB4
    jsr Print2x2

    lda #LeftEnd+4 | sta <ZB2
    lda #4 | sta <ZB3
    lda #low Str.Chars | sta <ZW0.low
    lda #high Str.Chars | sta <ZW0.high
    jsr PrintS
 
    lda #LeftEnd+10 | sta <ZB2
    lda #8 | sta <ZB3
    lda #low Str.Man | sta <ZW0.low
    lda #high Str.Man | sta <ZW0.high
    jsr PrintS

    lda #LeftEnd+10 | sta <ZB2
    lda #11 | sta <ZB3
    lda #low Str.Chaser | sta <ZW0.low
    lda #high Str.Chaser | sta <ZW0.high
    jsr PrintS

    lda #LeftEnd+10 | sta <ZB2
    lda #14 | sta <ZB3
    lda #low Str.Disturber | sta <ZW0.low
    lda #high Str.Disturber | sta <ZW0.high
    jsr PrintS

    lda #LeftEnd+10 | sta <ZB2
    lda #17 | sta <ZB3
    lda #low Str.Exit | sta <ZW0.low
    lda #high Str.Exit | sta <ZW0.high
    jsr PrintS

    lda #LeftEnd+4 | sta <ZB2
    lda #21 | sta <ZB3
    lda #low Str.Push | sta <ZW0.low
    lda #high Str.Push | sta <ZW0.high
    jsr PrintS
rts
